<?
/*
Plugin Name: Subscribe To Comments
Version: 1.4.4
Plugin URI: http://www.scriptygoddess.com/archives/2004/06/03/wp-subscribe-to-comments/
Description: Allows users(readers) to recieve notifications of new comments that are posted after their own.
Author: Jennifer - Scriptygoddess
Author URI: http://scriptygoddess.com

Additional Credits:
Updates by Romain - http://www.romain.info
- added international support
- added latest TLD's

Updates by Mark - http://www.TxFx.net 
- won't email commenters own comments
- comment_subscription_status() function

Update by Brian Meidell - http://meidell.dk/blog
- added check to see if "maybe_add_column()" function already exists
 
*/

/*
This name and email address below will be used as a contact method for users having difficulty or questions regarding the comment subscription feature, such as needing to be removed from the "do not mail" list. It will also be used as the "from" in the comment notifications. If you specify these

If these aren't specified, the FROM will be your admin email address
*/
$emailContact = "email@example.com";
$nameContact = "YOUR NAME";
///////////no need to edit below this line///////////////

if ($emailContact == "email@example.com") {
	$emailContact = get_settings("admin_email");
}
if ($nameContact == "YOUR NAME") {
	$nameContact = stripslashes(get_settings('blogname'));
}

/*
function to get an array of email addresses that are subscribed to the post id given
*/
function get_email_list($postid) {
	global $wpdb, $tablecomments;

	if (!isset($tablecomments)) 
		$tablecomments = $wpdb->comments;	
	
	
	$postid = (int) $postid;
	
	maybe_add_column($tablecomments, 'comment_subscribe', "ALTER TABLE $tablecomments ADD COLUMN comment_subscribe enum('Y','N') NOT NULL default 'N'");
	
	$emailList = $wpdb->get_results("SELECT comment_author_email FROM $tablecomments WHERE comment_post_ID = '$postid' AND comment_subscribe='Y' AND comment_author_email != '' GROUP BY LCASE(comment_author_email)");
	return $emailList;

}

/*
function to check if email address is in do not mail list
returns true / false
*/
function is_do_not_mail($email) {
	global $wpdb, $tableoptions;
	
	if (!isset($tableoptions)) 
		$tableoptions = $wpdb->options;	
	
	//set email to lowercase - this way, easier to compare emails later
	$email = strtolower($email);

	if(!$wpdb->get_var("SELECT option_id FROM $tableoptions WHERE option_name = 'do_not_mail'")) {
		$wpdb->query("INSERT INTO $tableoptions (option_name, option_type, option_value, option_admin_level) VALUES ('do_not_mail', 3, '', 8)");
	}

	$blocklist = get_settings('do_not_mail');
	$blocked_array = explode (' ', $blocklist);
	if (in_array($email, $blocked_array)) {
		return true;
	}
	return false;
	
}

/*
return post title
*/
function getPostTitle($postid) {
	global $wpdb, $tableposts;
	
	if (!isset($tableposts)) 
		$tableposts = $wpdb->posts;
	
	$postid = (int) $postid;
	return stripslashes($wpdb->get_var("SELECT post_title FROM $tableposts WHERE ID='$postid' LIMIT 1"));
}

function getPostTitleWithLink ($postid) {
	global $wpdb, $tableposts;
	$postid = (int) $postid;
	$post = $wpdb->get_row("SELECT post_title FROM $tableposts WHERE ID='$postid' LIMIT 1");
	$output = '<a href="'.get_permalink($postid).'">'.$post->post_title.'</a>';
	return $output;
}

/*
function to add a do not mail address.
returns true on success. false if already in database/not successful.
*/
function add_do_not_mail($email) {
	global $wpdb, $tableoptions;
	
	if (!isset($tableoptions)) 
		$tableoptions = $wpdb->options;	
	
	// set email to lowercase - this way, easier to compare emails later
	$email = strtolower($email);
	// does blocked column exist?
	if(!$wpdb->get_var("SELECT option_id FROM $tableoptions WHERE option_name = 'do_not_mail'")) {
		$wpdb->query("INSERT INTO $tableoptions (option_name, option_type, option_value, option_admin_level) VALUES ('do_not_mail', 3, '', 8)");
	}
	
	$blocklist = $wpdb->get_var("SELECT option_value FROM $tableoptions WHERE option_name = 'do_not_mail'");

	// check to make sure this email isn't already in there
	if (!is_do_not_mail($email)) {
		// email hasn't already been added - so add it
		$blocklist = $blocklist . ' ' . $email;
		update_option('do_not_mail', $blocklist);
		return true;
	}
	return false;
}

/*
function to remove a do not mail address.
returns true on success. false if not in database/not successful.
*/
function remove_do_not_mail($email) {
	global $wpdb, $tableoptions;

	if (!isset($tableoptions)) 
		$tableoptions = $wpdb->options;	
	
	$email = strtolower($email);
	$blocklist = get_settings('do_not_mail');
	
	$blocked_array = explode (' ', $blocklist);
		
	if (in_array($email, $blocked_array)) {
		//email is in the list - so remove it
		$blocklist = str_replace ($email, '', $blocklist);
		update_option('do_not_mail', $blocklist);
		return true;
	}
	return false;
}


/*
Select all subscriptions for an email - returns an array of post_ids that email is subscribed to
*/
function get_subscriptionlist($email) {
	global $wpdb, $tablecomments;
	
	if (!isset($tablecomments)) 
		$tablecomments = $wpdb->comments;
		
	$email = $wpdb->escape(strtolower($email));
			
	$subscriptionList = $wpdb->get_results("SELECT comment_post_ID FROM $tablecomments WHERE LCASE(comment_author_email) = '$email' AND comment_subscribe='Y' GROUP BY comment_post_ID");
	$subscrips = '';
	$i = 0;
	if ($subscriptionList) {
		foreach ($subscriptionList as $subscriptionList) {
			$subscrips[$i] = $subscriptionList->comment_post_ID;
			$i++;
		}
		return $subscrips; 
	}
}

/*
add flag to commenter if they're subscribing to post, or have ever subscribed to post
*/
function add_comment_subscriber ($commentid) {
    global $wpdb, $tablecomments, $tableposts;
   
    if (!isset($tablecomments))
        $tablecomments = $wpdb->comments;
       
    if (!isset($tableposts))
        $tableposts = $wpdb->posts;           
   
    if (!$commentid)
    $commentid = $wpdb->insert_id;
   
    $commentid = (int) $commentid;
    
    maybe_add_column($tablecomments, 'comment_subscribe', "ALTER TABLE $tablecomments ADD COLUMN comment_subscribe enum('Y','N') NOT NULL default 'N'");

$email = $wpdb->escape(strtolower($_POST['email']));   
$postId = $wpdb->get_var("SELECT comment_post_ID from $tablecomments WHERE comment_ID = '$commentid'");

// returns 'Y' if the user has previously subscribed, and NULL if not
$has_previously_subscribed = $wpdb->get_var("SELECT comment_subscribe from $tablecomments WHERE comment_post_ID = '$postId' AND LCASE(comment_author_email) = '$email' AND comment_subscribe = 'Y' LIMIT 1");

    // I added "|| $has_previously_subscribed" to the conditional, and then modified the UPDATE query to set comment_subscribe = 'Y' for all comments that match that e-mail address on that entry
    //if user wants to be notified - set flag
    if (($_POST['subscribe'] == 'subscribe' && $_POST['email'] != "" && validate_email($_POST['email'])) || $has_previously_subscribed) {
        $wpdb->query("UPDATE $tablecomments SET comment_subscribe = 'Y' where comment_post_ID = '$postId' AND LCASE(comment_author_email) = '$email'");
            }
           return $commentid;
}





/*
remove flag(s) on commenter if they're unsubscribing to post
*/
function remove_comment_subscriber ($email, $postId) {
	global $wpdb, $tablecomments;
	if (!isset($tablecomments)) 
		$tablecomments = $wpdb->comments;
	$postId = (int) $postId;
	$email = $wpdb->escape(strtolower($email));	
	
	$wpdb->query("UPDATE $tablecomments SET comment_subscribe = 'N' where comment_post_ID  = '$postId' AND LCASE(comment_author_email) ='$email'");
		
}

/*
removes subscription flags for several comments - pass an array of post ids and email
*/
function remove_many_comment_subscriptions ($email, $postidarray) {
	global $wpdb, $tablecomments;
	
	if (!isset($tablecomments)) 
		$tablecomments = $wpdb->comments;

	for ($i = 0; $i < count($postidarray); $i++) {
		remove_comment_subscriber ($email, $postidarray[$i]);
	}
}

/*
Copied directly from upgrade-functions.php - just didn't want to load all the other functions.
*/
if(!function_exists('maybe_add_column')) {
	function maybe_add_column($table_name, $column_name, $create_ddl) {
	    global $wpdb, $debug;
	    foreach ($wpdb->get_col("DESC $table_name", 0) as $column ) {
	        if ($debug) echo("checking $column == $column_name<br />");
	        if ($column == $column_name) {
	            return true;
	        }
	    }
	    //didn't find it try to create it.
	    $q = $wpdb->query($create_ddl);
	    // we cannot directly tell that whether this succeeded!
	    foreach ($wpdb->get_col("DESC $table_name", 0) as $column ) {
	        if ($column == $column_name) {
	            return true;
	        }
	    }
	    return false;
	}
}

/*
send out comment notifications
*/
function send_comment_subscription($commentid) {
	global $wpdb, $tablecomments, $tableposts, $emailContact, $nameContact;

	if (!isset($tablecomments)) 
		$tablecomments = $wpdb->comments;
	if (!isset($tableposts)) 
		$tableposts = $wpdb->posts;			
	
	$commentid = (int) $commentid;
	
	maybe_add_column($tablecomments, 'comment_subscribe', "ALTER TABLE $tablecomments ADD COLUMN comment_subscribe enum('Y','N') NOT NULL default 'N'");
	
	$comment = $wpdb->get_row("SELECT * FROM $tablecomments WHERE comment_ID='$commentid' LIMIT 1");
	$post = $wpdb->get_row("SELECT * FROM $tableposts WHERE ID='$comment->comment_post_ID' LIMIT 1");
	
	if ($comment->comment_approved > 0) {
	//if comment is going live...
		
		$subscrip_notify_message  = "There is a new comment on the post \"".stripslashes($post->post_title). "\"\r\n".get_permalink($comment->comment_post_ID)."\r\n\r\n";
		$subscrip_notify_message .= "Author : ".$comment->comment_author."\r\n";
		$subscrip_notify_message .= "Comment:\r\n".stripslashes($comment->comment_content)."\r\n\r\n";
		$subscrip_notify_message .= "See all comments on this post here:\r\n";
		$subscrip_notify_message .= get_permalink($comment->comment_post_ID) . "#comments\r\n\r\n";
		//add link to manage comment notifications
		$subscrip_notify_message .= "To manage your subscriptions or to block all notifications from this site, click the link below:\r\n";
		$subscrip_notify_message .= get_settings('siteurl')."/wp-subscription-manager.php";
		
		$subscip_subject = "[" . stripslashes(get_settings('blogname')) ."] New Comment On: ".stripslashes($post->post_title);
		
		$headers  = "From: ".$nameContact." <".$emailContact.">\r\n";
		$headers .= "MIME-Version: 1.0\r\n"
		. "Content-Type: text/plain; charset=\"" . get_settings('blog_charset') . "\"\r\n";
		
		$notifyEmails = get_email_list($comment->comment_post_ID);
		
		if (count($notifyEmails) > 0) {
			foreach($notifyEmails as $email) {
				if (!is_do_not_mail($email->comment_author_email) && $email->comment_author_email != $comment->comment_author_email) {
					mail ($email->comment_author_email, $subscip_subject, $subscrip_notify_message, $headers);
				}	
			}
		}
	} //end if comment approved
	return $commentid;
}

/*
This funcion Validates email address - so we're not sending email subscriptions to badly formed emails
Originally grabbed this function from here: http://www.phpfreaks.com/quickcode/Email_Validation_-_checks_ALL_top_level_domains/102.php
edits to this were done by Romain (http://www.romain.info)
returns true of false
*/
function validate_email($str) {
$str = strtolower($str);
if(ereg("^([^[:space:]]+)@(.+)\.(ad|ae|aero|af|ag|ai|al|am|an|ao|aq|ar|arpa|as|at|au|aw|az|ba|bb|bd|be|bf|bg|bh|bi|biz|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|coop|com|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|eh|er|es|et|fi|fj|fk|fm|fo|fr|fx|ga|gb|gov|gd|ge|gf|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|in|info|int|io|iq|ir|is|it|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|mg|mh|mil|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|museum|mv|mw|mx|my|mz|na|name|nato|nc|ne|net|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|pt|pw|py|qa|re|ro|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)$",$str)){
return true;
} else {
return false;
}
}

/*
use this function on your comments display - to show whether a user is subscribed to comments on the post or not.
comment_subscription_status() function thanks to Mark: http://www.TxFx.net 
*/
function comment_subscription_status() {
global $comment;
if ($comment->comment_subscribe == 'Y') {
return TRUE;
} else {
return FALSE;
}   
}


add_action('comment_post', 'send_comment_subscription');
add_action('comment_post', 'add_comment_subscriber');

add_action('wp_set_comment_status', 'send_comment_subscription');


?>